#!/usr/bin/env python
import sys
import re
import json

_VALID_URL = r"""(?:
					(?:https?://)?
					(?:\w+\.)?
					youtube\.com/
					(?:
					   (?:course|view_play_list|my_playlists|artist|playlist|watch)
					   \? (?:.*?&)*? (?:p|a|list)=
					|  p/
					)
					((?:PL|EC|UU|FL)?[0-9A-Za-z-_]{10,})
					.*
				 |
					((?:PL|EC|UU|FL)[0-9A-Za-z-_]{10,})
				 )"""

def Is_Playlist_Url(url):
	if re.match(_VALID_URL, url, re.VERBOSE) is not None:
		obj =  {'success': True}
	else:
		obj =  {'success': False}
	return json.dumps(obj)

def Usage():
	print 'Usage:  vd_util.py options url'
	print 'Options:'
	print ' --check-playlist'

if __name__ == '__main__':
	if len(sys.argv) < 3:
		Usage()
		sys.exit(0)
	if '--check-playlist' == sys.argv[1]:
		print Is_Playlist_Url(sys.argv[2])
	else:
		Usage()